hdu 1258 DFS

I - 深搜 基础

Crawling in process... Crawling failed Time Limit:1000MS     Memory Limit:10000KB     64bit IO Format:%I64d & %I64u

Submit Status

Description

Given a specified total t and a list of n integers, find all distinct sums using numbers from the list that add up to t. For example, if t = 4, n = 6, and the list is [4, 3, 2, 2, 1, 1], then there are four different sums that equal 4: 4, 3+1, 2+2, and 2+1+1. (A number can be used within a sum as many times as it appears in the list, and a single number counts as a sum.) Your job is to solve this problem in general.

Input

The input will contain one or more test cases, one per line. Each test case contains t, the total, followed by n, the number of integers in the list, followed by n integers x 1 , . . . , x n . If n = 0 it signals the end of the input; otherwise, t will be a positive integer less than 1000, n will be an integer between 1 and 12 (inclusive), and x 1 , . . . , x n will be positive integers less than 100. All numbers will be separated by exactly one space. The numbers in each list appear in nonincreasing order, and there may be repetitions.

Output

For each test case, first output a line containing `Sums of', the total, and a colon. Then output each sum, one per line; if there are no sums, output the line `NONE'. The numbers within each sum must appear in nonincreasing order. A number may be repeated in the sum as many times as it was repeated in the original list. The sums themselves must be sorted in decreasing order based on the numbers appearing in the sum. In other words, the sums must be sorted by their first number; sums with the same first number must be sorted by their second number; sums with the same first two numbers must be sorted by their third number; and so on. Within each test case, all sums must be distinct; the same sum cannot appear twice.

Sample Input

4 6 4 3 2 2 1 1
5 3 2 1 1
400 12 50 50 50 50 50 50 25 25 25 25 25 25
0 0

Sample Output

Sums of 4:
4
3+1
2+2
2+1+1
Sums of 5:
NONE
Sums of 400:
50+50+50+50+50+50+25+25+25+25
50+50+50+50+50+25+25+25+25+25+25

题意比较好懂,解析见代码
代码:
/*
 hdu1258
dfs,小数据,dfs暴力搜一遍即可,之前一直做一些图的题目,这算是做的
第一道比较抽象的dfs题目,dfs最重要的思想是递归与回溯来实现状态的转移,是
一种暴力的搜索手段,适用于小数据的情况
*/
#include<iostream>
#include <cstdio>
#include <algorithm>
#include <cstring>
#include <cmath>
#include <queue>
#include <stack>
using namespace std;
const int maxn=15;
const double epi=1e-8;
const double pi=acos(-1.0);
int a[maxn],b[maxn];
bool v[maxn];//标记数组,避免在一次搜索中重复搜索
int tar,n;
bool flag;
void dfs(int sum,int pos,int ans)//三个参数,sum代表当前层计数总和,判断递归是否结束的标志,pos储存下一次从哪一个位置开始搜索
{
    int i;
    if(sum>tar) return;
    if(sum==tar)
    {
        flag=true;
        for(int i=1;i<=ans;i++)
      printf((i==ans)?"%d ":"%d+",b[i]);//输出注意格式
    }
    int last=-1;
    for(i=pos+1;i<=n;i++)
    {
        if(!v[i]&&a[i]!=last)
        {
            b[ans+1]=a[i];
            last=a[i];
            v[i]=true;
            dfs(sum+a[i],i,ans+1);
            v[i]=false;
        }
    }
}
int main()
{
    while(scanf("%d%d",&tar,&n)&&(tar||n))
    {
        for(int i=1;i<=n;i++)
        scanf("%d",&a[i]);
        memset(v,false,sizeof(v));
        cout<<"Sums of "<<tar<<":"<<endl;
        flag=false;//判断是否找到答案
        dfs(0,0,0);
        if(!flag)
            cout<<"NONE"<<endl;
    }
}
原文地址:https://www.cnblogs.com/xuejianye/p/5569199.html